<?php

/**
 * Settings form for the current module.
 *
 * @param array $form_state
 *   Form_state array.
 *
 * @return array
 *   Array containing the system settings form.
 */
function drd_agent_settings(&$form_state) {
  $form = array();
  $form['drd_agent_debug_mode'] = array(
    '#type' => 'checkbox',
    '#title' => t('Debug mode'),
    '#default_value' => variable_get('drd_agent_debug_mode', FALSE),
  );

  return system_settings_form($form);
}

/**
 * Callback that receives all relevant parameters from a monitoring DRD instance
 * base64 encoded and serialized in $values. This is called by a menu callback
 * or from drush.
 *
 * Security note: if called through a http request, this should only be done
 * over https as otherwise those parameters are travelling in plain text.
 *
 * @param string $values
 */
function drd_agent_setup($values) {
  $values = strtr($values, array('-' => '+', '_' => '/'));
  $values = unserialize(base64_decode($values));
  $authorised = variable_get('drd_agent_authorised', array());

  $values['timestamp'] = REQUEST_TIME;
  $values['ip'] = ip_address();
  $authorised[$values['uuid']] = $values;

  variable_set('drd_agent_authorised', $authorised);
  if (!empty($values['redirect'])) {
    drupal_goto($values['redirect']);
  }
}
